summaryrefslogtreecommitdiff
path: root/meta-facebook/recipes-phosphor/state/phosphor-state-manager/greatlakes/host-poweron
diff options
context:
space:
mode:
Diffstat (limited to 'meta-facebook/recipes-phosphor/state/phosphor-state-manager/greatlakes/host-poweron')
-rw-r--r--meta-facebook/recipes-phosphor/state/phosphor-state-manager/greatlakes/host-poweron39
1 files changed, 39 insertions, 0 deletions
diff --git a/meta-facebook/recipes-phosphor/state/phosphor-state-manager/greatlakes/host-poweron b/meta-facebook/recipes-phosphor/state/phosphor-state-manager/greatlakes/host-poweron
new file mode 100644
index 0000000000..234423e46e
--- /dev/null
+++ b/meta-facebook/recipes-phosphor/state/phosphor-state-manager/greatlakes/host-poweron
@@ -0,0 +1,39 @@
+#!/bin/bash
+
+# Provide source directive to shellcheck.
+# shellcheck source=meta-facebook/recipes-phosphor/state/phosphor-state-manager/greatlakes/power-cmd
+source /usr/libexec/power-cmd
+
+SLOT_ID=$(( $1-1 << 2 ))
+# Host Power On
+host-power-on()
+{
+ for pwr_cmd in "${power_seq[@]}"
+ do
+ result="$(busctl call $SERVICE $OBJECT_PATH $INTERFACE sendRequest yyyyay $SLOT_ID $NETFN $LUN $CMD $DATA_LEN 0x01 0x42 0x01 0x00 "$pwr_cmd")"
+ echo "$result"
+ if [ "$pwr_cmd" == $POWER_BTN_LOW ]
+ then
+ sleep 2
+ fi
+ done
+ echo "Host power on"
+ exit 0;
+}
+
+# Check Host Response and Status
+host-power-status()
+{
+ response="$(busctl call $SERVICE $OBJECT_PATH $INTERFACE sendRequest yyyyay $SLOT_ID 0x38 $LUN 0x03 0x03 0x15 0xa0 0x00)"
+
+ result=$(echo "$response" | cut -d" " -f $PWRGD_SYS_PWROK_INDEX)
+ res="$(( "$result" & 0x80 ))"
+ pgood="$(( "$res" >> 7 ))"
+ if [ "$pgood" == $STATE_OFF ]
+ then
+ host-power-on
+ fi
+ echo "Power is already on"
+ exit 1;
+}
+host-power-status